// module_test.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "../stdafx.h"
#include "../TsStreamEngine/TsStream.h"

#ifdef _DEBUG
#define CATCH_INT_ERROR_CODE(err_code) {char err_buf[255];wsprintf(err_buf,"%s() errcode=%d\n",__FUNCTION__,err_code);OutputDebugString(err_buf);}
#else
#define CATCH_INT_ERROR_CODE(err_code) {err_code=err_code;/*rhwarningp_~[*/}
#endif

void CALLBACK TsCallbackTest(UINT uType,WORD wStreamID,LPVOID pData,DWORD dwVal,LPVOID lpContext)
{
	DWORD *pdwSize=(DWORD*)lpContext;

	switch(uType)
	{
	case TSENG_CALLBACK_PACKET:
		{
			WORD wNo=wStreamID;
			if(wNo==0)
			{
				(*pdwSize)+=dwVal;
			}
		}
		break;
	case TSENG_CALLBACK_STREAM_RESET:
		{
			::_tprintf(TEXT("\n<< Stream Reset >>\n"));
		}
		break;
	case TSENG_CALLBACK_PAT_RECIEVE:
		{
			::_tprintf(TEXT("\n<< PAT Update(0x%04X) >>\n"),wStreamID);
			struct TAG_TSCB_PATITEM *pstPatItem=(struct TAG_TSCB_PATITEM *)pData;
			for(unsigned int i=0;i<dwVal;i++)
			{
				::_tprintf(TEXT("\tProgNo=%5d , PmtPID=0x%04X\n"),pstPatItem[i].wProgramID,pstPatItem[i].wPID);
			}
		}
		break;
	case TSENG_CALLBACK_PMT_RECIEVE:
		{
			::_tprintf(TEXT("\n<< PMT Update(%d) >>\n"),wStreamID);
			struct TAG_TSCB_PMTITEM *pstPmtItem=(struct TAG_TSCB_PMTITEM *)pData;
			for(unsigned int i=0;i<dwVal;i++)
			{
				::_tprintf(TEXT("\tPmtPID=0x%04X(0x%X)\n"),pstPmtItem[i].wPID,pstPmtItem[i].byType);
			}
		}
		break;
	case TSENG_CALLBACK_NIT_RECIEVE:
		{
			::_tprintf(TEXT("\n<< Network >> ID=%04X Name=%s \n"),wStreamID,pData);
		}
		break;
	case TSENG_CALLBACK_SATELLITE_INFO:
		{
			struct TAG_TSCB_SATELLITE *pstSatellite = (struct TAG_TSCB_SATELLITE*)pData;
			::_tprintf(TEXT("\n<< SATELLITE >> NetID=%04X TsID=%04X\n"),wStreamID,dwVal);
			::_tprintf(TEXT("\t%s%.1lf%.5lfGHz %sΔg %s Rate=%.2lf Mbps\n"),
				pstSatellite->bEastFlg?"o":"a",pstSatellite->lfPosition,
				pstSatellite->lfFrequency/1000.0,
				pstSatellite->byPolarization==0?"":pstSatellite->byPolarization==1?"":pstSatellite->byPolarization==2?"":pstSatellite->byPolarization==3?"E":"s",
				pstSatellite->byModulation==1?"QPSK":pstSatellite->byModulation==8?"TC8PSK(BSD)":"s",
				pstSatellite->lfRate
				);
		}
		break;
	case TSENG_CALLBACK_TIME_RECIEVE:
		{
			struct TAG_TSCB_TIME *pstTime=(struct TAG_TSCB_TIME *)pData;
			::_tprintf(TEXT("\n<< Time >> MJD=%d %02d:%02d:%02d \n"),pstTime->stDateTime.Date,pstTime->byHour,pstTime->byMin,pstTime->bySec);
		}
		break;
	case TSENG_CALLBACK_SDT_RECIEVE:
		{
			char *pszBuf=new char[20];
			lstrcpyn(pszBuf,(char*)pData,20);
			::_tprintf(TEXT("<< ServiceName >> %d=\"%s\"\n"),wStreamID,pszBuf);
			delete []pszBuf;
		}
		break;
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
#ifdef DETECT_MEMORY_LEAK
	int flag = ::_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG);
	::_CrtSetDbgFlag(flag | _CRTDBG_LEAK_CHECK_DF);
#endif

	CTsStream *m_pTsStream;	
	struct TS_StreamInfo	m_stStreamInfo;
	ZeroMemory(&m_stStreamInfo,sizeof(struct TS_StreamInfo));

	try
	{
		CB25 *pB25=NULL;
		bool b25Proc= false;
		if(b25Proc)
		{
			pB25 = new CB25();
			if(!pB25)
			{
				_tprintf(TEXT("Can not init B25 class."));
				throw 101;
			}
			if(!pB25->Open("B25Decoder.dll"))
			{
				_tprintf(TEXT("B25Decord.dll init error."));
			}
			if(!pB25->Initialize())
			{
				_tprintf(TEXT("B-CAS card error"));
				throw 104;
			}
		}

		m_pTsStream=new CTsStream(pB25);
		if(!m_pTsStream)
		{
			::_tprintf(TEXT("srXg[NX̃I[vɎs܂\n"));
			throw 4;
		}

		DWORD dwReadSize = 0,dwCallbackSize = 0,dwCount=0;
		m_pTsStream->SetDecodePSI(true);
		m_pTsStream->SetEpgProc(true);
		m_pTsStream->SetCallbackFunc(TsCallbackTest,&dwCallbackSize);

		// t@C̃I[v

		FILE *fp=_tfopen(_T("f:\\ts_sample\\non_scramble\\CCErr.ts"),_T("rb"));
		if(!fp)
		{
			::_tprintf(TEXT("t@C̃I[vɎs܂B\n"));
			throw 4;
		}
		
		::_tprintf(TEXT("Jn\n"));
		DWORD dwStart=GetTickCount();
		BYTE buf[0x8000];
		while(1)
		{
			DWORD len=static_cast<DWORD>(fread(buf,1,0x8000,fp));
			dwReadSize+=len;
			if(len==0) break;
			m_pTsStream->OnTsStream(buf,len,&m_stStreamInfo);
			if((++dwCount)%32==0) ::_tprintf(TEXT("."));
		}
		fclose(fp);
		::_tprintf(TEXT("\n"));
		div_t a=div(GetTickCount()-dwStart,1000);		
		::_tprintf(TEXT("I(%d.%03dsec)\n"),a.quot,a.rem);
		::_tprintf(TEXT("̓TCY@@@ = %d byte\n"),dwReadSize);		
		::_tprintf(TEXT("o̓TCY@@@ = %d byte\n"),dwCallbackSize);
		::_tprintf(TEXT("\n"));
		::_tprintf(TEXT("IpPbgTCY@ = %d byte\n"),m_stStreamInfo.wTsPacketLen);
		::_tprintf(TEXT("G[@@@ = %d \n"),m_stStreamInfo.dwTsSyncFail);
		::_tprintf(TEXT("JE^G[@ = %d \n"),m_stStreamInfo.dwTsPacketDrop);
		::_tprintf(TEXT("o͈ÍpPbg = %d \n"),m_stStreamInfo.dwScramblePacket);

		// EPGp
		/*
		struct TSEPG_PROGRAM *pstFind = m_pTsStream->FindEpgDataByTime(103,54517,1*3600+00*60+1,TRUE);
		if(pstFind)
		{
			m_pTsStream->FreeEpgDataMemory(pstFind,1);
		}
		*/

		if(pB25) delete pB25;
		delete m_pTsStream;
	}
	catch(int err_code)
	{
		CATCH_INT_ERROR_CODE(err_code);

	}	
	return 0;
}

